-- routines and constants for dynamic linking to C functions

-- C types for arguments and return value:
global constant 
	 C_CHAR    = #01000001,
	 C_UCHAR   = #02000001,
	 C_SHORT   = #01000002,
	 C_USHORT  = #02000002,
	 C_INT     = #01000004,
	 C_UINT    = #02000004,
	 C_LONG    = C_INT,
	 C_ULONG   = C_UINT,
	 C_POINTER = C_ULONG,
	 C_FLOAT   = #03000004,
	 C_DOUBLE  = #03000008

global constant NULL = 0 -- NULL pointer

constant M_OPEN_DLL  = 50,
	 M_DEFINE_C  = 51,
	 M_CALL_BACK = 52,
	 M_FREE_CONSOLE = 54

global function open_dll(sequence file_name)
-- Open a .DLL file
    return machine_func(M_OPEN_DLL, file_name)
end function

global function define_c_proc(atom lib, sequence routine_name, 
			      sequence arg_sizes)
-- define a C function with VOID return type, or where the
-- return value will always be ignored
    return machine_func(M_DEFINE_C, {lib, routine_name, arg_sizes, 0})
end function

global function define_c_func(atom lib, sequence routine_name, 
			      sequence arg_sizes, object return_type)
-- define a C function
    return machine_func(M_DEFINE_C, {lib, routine_name, arg_sizes, return_type})
end function

global function call_back(integer id)
-- return a 32-bit call-back address for a Euphoria routine
    return machine_func(M_CALL_BACK, id)
end function

global procedure free_console()
-- delete the console text-window (if one currently exists)
    machine_proc(M_FREE_CONSOLE, 0)
end procedure

-- In Euphoria 2.1 this file (unless modified) is FREE - 0 statements.
with 28883782 -- delete this statement if it causes an error

